unit hiLabelEx;

interface

uses Kol,windows,Messages,Share,Win;

type
 THILabelEx = class(THIWin)
   private
     Bmp: Kol.PBitmap;
     procedure SetAutoSize(Value:boolean);
     procedure SetAlignment(Value:TTextAlign);
     procedure _OnClick( Sender: PObj );
   protected
     procedure _onMouseEnter(Sender: PObj); override;
     procedure _onMouseLeave(Sender: PObj); override;
     procedure DrawBackground;
     procedure Paint(Sender: PControl; DC: HDC);

   public
     _event_OnClick:THI_Event;
     _prop_ColorHover:integer;
     _prop_Underline:boolean;
     _prop_Caption:string;
     _prop_CaptionOnClick:boolean;
     _prop_DrawBackground:boolean;
     _data_Text:THI_Event;

     procedure _work_DoText(var Data:TData; Index:word);
     procedure _work_doAlignment(var Data:TData; Index:word);
     procedure _var_Caption(var Data:TData; Index:word);

     constructor Create(Parent:PControl);
     procedure Init; override;
     property _prop_AutoSize:boolean write SetAutoSize;
     property _prop_Alignment: TTextAlign write SetAlignment;
 end;

implementation

procedure THILabelEx.DrawBackground;
var
  rt, rt2: TRect;
  pos,org: TPoint;
  hParent: HWND;
  scrDC: HDC;
begin
  begin
    try
        if Assigned(Bmp) then Bmp.Free;
        Bmp := NewBitmap(Control.Width,Control.Height);
        Bmp.PixelFormat := pf32bit;
        pos := Control.Position;
        dec(pos.X); dec(pos.Y);
        hParent := ChildWindowFromPoint(FParent.GetWindowHandle,pos);
        scrDC := Bmp.Canvas.Handle;
        GetWindowRect(Control.GetWindowHandle, rt);
        GetWindowRect(hParent, rt2);
        rt.Left := Abs(rt.Left - rt2.Left);
        rt.Top  := Abs(rt.Top - rt2.Top);
        OffsetViewportOrgEx(scrDC, -rt.left, -rt.top, org);
        SendMessage(hParent, WM_ERASEBKGND, scrDC, 0);
        SendMessage(hParent, WM_PRINTCLIENT, scrDC, PRF_CLIENT);
        SetViewportOrgEx(scrDC, org.x, org.y, nil);
    except

    end;
  end;
end;

procedure THILabelEx.Paint(Sender: PControl; DC: HDC);
var
  J: integer;
  R: TRect;
begin
  DrawBackground;
  Bmp.Canvas.Font.Assign(Control.Font);
  case Integer(Control.TextAlign) of
    0: J := DT_LEFT;
    1: J := DT_RIGHT;
    2: J := DT_CENTER;
  end;
  R := MakeRect(0, 0, Bmp.Width, Bmp.Height);
  Bmp.Draw(Control.Canvas.Handle,0,0);
  Bmp.Canvas.Brush.BrushStyle := bsClear;
  Bmp.Canvas.DrawText(_prop_Caption, R, J or DT_WORDBREAK or DT_NOPREFIX);
  Bmp.Draw(Control.Canvas.Handle,0,0);
end;

constructor THILabelEx.Create;
begin
  inherited Create(Parent);
  Control := NewLabel(Parent,'');
  Control.OnClick := _OnClick;
end;

procedure THILabelEx.Init;
begin
   inherited;
   Bmp := NewBitmap(Control.Width,Control.Height);
   Bmp.PixelFormat := pf32bit;
   Bmp.Canvas.Brush.Color := Color2RGB(_prop_Color);
   Bmp.Canvas.Brush.BrushStyle := bsSolid;
   Bmp.Canvas.FillRect(MakeRect(0,0,Bmp.Width,Bmp.Height));
   Bmp.Canvas.Font.Assign(Control.Font);
   Control.AutoSize(False);
   //Control.VerticalAlign := _prop_VAlignment;
   Control.Caption := _prop_Caption;
   if (_prop_ColorHover <> 0) or _prop_Underline then
    begin
     Control.onMouseEnter := _OnMouseEnter;
     Control.onMouseLeave := _OnMouseLeave;
    end;
   if not _prop_Visible  then
     Control.Visible := False;

   Control.OnPaint := Paint;
end;

procedure THILabelEx._OnClick;
begin
   if _prop_CaptionOnClick then
     _hi_OnEvent(_event_OnClick, Control.Caption)
   else
     _hi_OnEvent(_event_OnClick);
end;

procedure THILabelEx._OnMouseEnter;
begin
   inherited;
   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_ColorHover;
//   if _prop_Cursor <> 0 then
//      Control.Cursor := _prop_Cursor;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle + [fsUnderline];
end;

procedure THILabelEx._OnMouseLeave;
begin
   inherited;
   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_Font.Color;
//   if _prop_Cursor <> 0 then
//      Control.Cursor := crDefault;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle - [fsUnderline];
end;

procedure THILabelEx._work_DoText;
begin
   Control.Caption := ReadString(Data,_data_Text);
end;

procedure THILabelEx._work_doAlignment;
begin
  Control.TextAlign := TTextAlign(ToInteger(Data));
end;

procedure THILabelEx.SetAlignment;
begin
  Control.TextAlign := Value;
end;

procedure THILabelEx.SetAutoSize;
begin
   Control.AutoSize( Value );
end;

procedure THILabelEx._var_Caption;
begin
   dtString(Data,Control.Caption);
end;

end.
